//
//  Copyright (C) 2003, .
//
//  PROJECT:    
//
//  MODULE:     mainwnd.cpp
//
//  PURPOSE:       
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows 2000/XP/NT/9x
//
//  CLASSES:  
//       CMainWnd
//

#include "stdwtl.h"
#include "mainwnd.h"
#include "waitcursor.h"
#include "message.h"
#include "otherdlg.h"

//////////////////////////////////////////////////////////////////////
//
//  CMainWindow
//
//////////////////////////////////////////////////////////////////////

//  
//  FUNCTION:     CMainWindow(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:      .    
//                   
//
//  COMMENTS:     
//
CMainWindow::CMainWindow() : _go(false), _loading(false)
{
	GetWndClassInfo().m_wc.hbrBackground = (HBRUSH)GetStockObject(NULL_BRUSH);
	GetWndClassInfo().m_wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
	GetWndClassInfo().m_wc.hIcon         = NULL;
	GetWndClassInfo().m_wc.hIconSm       = GetWndClassInfo().m_wc.hIcon;
}

//  
//  FUNCTION:     ~CMainWindow(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:      . 
//
//  COMMENTS:     
//
CMainWindow::~CMainWindow()
{
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

//  
//  FUNCTION:     LRESULT OnCreate(CREATESTRUCT*)
//
//  PARAMETERS:   [IN] cs -   
//
//  RETURN VALUE: 0  -  
//                -1 -   
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:        
//
//  COMMENTS:     
//
LRESULT CMainWindow::OnCreate(CREATESTRUCT* cs)
{
	_splitter.Create(
				*this, 
				rcDefault, 
				NULL, 
				WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
				0);

	_splitter.m_cxySplitBar /= 2;

	if (_tree.Create(_splitter) && _view.Create(_splitter)) 
	{
		_splitter.SetSplitterPanes(_tree, _view);

		RECT rc = {0, 0, 100, 100};
		_splitter.SetSplitterRect(&rc);
		_splitter.SetSplitterPos(30);

		SetTimer(1, 100);

		return 0;
	}
	
	return -1;
}

//  
//  FUNCTION:     void OnSize(UINT, CSize)
//
//  PARAMETERS:   [IN] type -  
//                [IN] s    -  
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:           
//                   .
//
//  COMMENTS:     
//
void CMainWindow::OnSize(UINT, CSize s)
{
	_splitter.MoveWindow(0, 0, s.cx, s.cy);
}

//  
//  FUNCTION:     void OnClose(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:       .
//
//  COMMENTS:     
//
void CMainWindow::OnClose()
{
	SetMsgHandled(FALSE);
}

void CMainWindow::OnInitMenu(HMENU hMenu, UINT, BOOL)
{
	DWORD enable = MF_BYCOMMAND;

	if (_data.IsConnected())
	{
		enable |= MF_ENABLED; 
	}
	else
	{
		enable |= MF_GRAYED;
	}

	EnableMenuItem(hMenu, ID_GO,   enable);
	EnableMenuItem(hMenu, ID_STOP, enable);
}

//  
//  FUNCTION:     void OnDestroy(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:       .
//
//  COMMENTS:     
//
void CMainWindow::OnDestroy()
{
	PostQuitMessage(0);
}


void CMainWindow::OnTimer(UINT id, TIMERPROC*)
{
	if (!_go) return;

	// !!!     dll  Open   !
	//     .      
	// WM_TIMER       ,  . ..
	// ,  .
	if (_loading) return;

	_loading = true;

	if (!LoadData(false))
	{
		_go = false;
	}

	_loading = false;
}

//////////////////////////////////////////////////////////////
//
//   
//
//////////////////////////////////////////////////////////////

void CMainWindow::OnConnect(UINT code, int id, HWND hCtrl)
{
	_go = false;

	COtherDialog<IDD_OTHER_CONNECT> cd(IDC_CONNECT);

	if (!cd.DoModal(*this)) return;

	int res;

	{
		CWaitCursor wc;

		res = _data.Connect(cd.get_s());
	}

	if (res != 0)
	{
		message::format_error(*this, IDS_E_CONNECT, res);
		return;
	}
}

void CMainWindow::OnGo(UINT code, int id, HWND hCtrl)
{
	if (!_data.IsConnected()) return;

	_go = true;
	_tree.Clear();
}

void CMainWindow::OnStop(UINT code, int id, HWND hCtrl)
{
	if (!_data.IsConnected()) return;

	_go = false;
	LoadData(true);
}

void CMainWindow::OnExit(UINT code, int id, HWND hCtrl)
{
	SendMessage(WM_CLOSE, 0);
}

void CMainWindow::OnAbout(UINT code, int id, HWND hCtrl)
{
	CSimpleDialog<IDD_ABOUT> a;
	a.DoModal();
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

LRESULT CMainWindow::OnTreeSetChange(LPNMHDR nmhdr)
{
	if (_go) return 0; 

	_view.Redraw(_data.GetCount(), _data.Get(), _tree.GetCurrentItem());
	return 0;
}

///////////////////////////////////////////////////////////
//
//  
//
///////////////////////////////////////////////////////////

bool CMainWindow::LoadData(bool tree)
{
	int res = _data.Load();

	if (res != 0)
	{
		message::format_error(*this, IDS_E_LOAD, res);
		return false;
	}

	_view.Redraw(_data.GetCount(), _data.Get());

	if (tree)
	{
		_tree.Fill(_data.GetCount(), _data.Get());
	}

	return true;
}

///////////////////////////////////////////////////////////
