//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     behemothloader.cpp
//
//  PURPOSE:    ,      
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//

#include "stdwtl.h"
#include "behemothloader.h"
#include "./perf/titledb.h"

////////////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////////////

CBehemothLoader::CBehemothLoader()
{
	_behemoth_index = -1;
}

CBehemothLoader::~CBehemothLoader()
{
}

//  
//  FUNCTION:     int Connect(const TCHAR* )
//
//  PARAMETERS:   [IN] computer -       NULL
//
//  RETURN VALUE:   
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:         ,  
//                   .   NULL   , 
//                   .
//
//  COMMENTS:     
// 
int CBehemothLoader::Connect(const TCHAR* computer)
{
	int res;
	title_DB db;

	res = db.LoadCounters(computer, 9);

	if (res != ERROR_SUCCESS)
	{
		return res;
	}

	int bh_index = db.Find(TEXT("Behemoth"));
	int s_index  = db.Find(TEXT("Behemoth Sex"));
	int a_index  = db.Find(TEXT("Behemoth age"));
	int x_index  = db.Find(TEXT("Behemoth X Coordinate"));
	int y_index  = db.Find(TEXT("Behemoth Y Coordinate"));
	int w_index  = db.Find(TEXT("Behemoth Weight"));
	int v_index  = db.Find(TEXT("Behemoth Volume"));
	int b_index  = db.Find(TEXT("Behemoth Birthday"));

	if (  (bh_index < 0)
		||(s_index  < 0)
		||(a_index  < 0)
		||(x_index  < 0)
		||(y_index  < 0)
		||(w_index  < 0)
		||(v_index  < 0)
		||(b_index  < 0))
	{
		// , ?
		return ERROR_FILE_NOT_FOUND;
	}

	res = _loader.Connect(computer);

	if (res != ERROR_SUCCESS)
	{
		return res;
	}

	_behemoth_index = bh_index;
	_sex_index      = s_index;
	_age_index      = a_index;
	_x_index        = x_index;
	_y_index        = y_index;
	_weight_index   = w_index;
	_volume_index   = v_index;
	_birthday_index = b_index;

	return 0;
}

//  
//  FUNCTION:     int Load()
//
//  PARAMETERS:   
//
//  RETURN VALUE:   
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:       ,  ,   
//
//  COMMENTS:     
// 
int CBehemothLoader::Load()
{
	_ASSERT(_behemoth_index >= 0);

	perf_object_type obj(0);

	//  ,  
	int res = LoadObject(_loader, _behemoth_index, &obj);

	if (res != ERROR_SUCCESS)
	{
		return res;
	}

	//    
	int s_offset = GetCounterOffset(obj, _sex_index);
	int a_offset = GetCounterOffset(obj, _age_index);
	int x_offset = GetCounterOffset(obj, _x_index);
	int y_offset = GetCounterOffset(obj, _y_index);
	int w_offset = GetCounterOffset(obj, _weight_index);
	int v_offset = GetCounterOffset(obj, _volume_index);
	int b_offset = GetCounterOffset(obj, _birthday_index);

	if (  (s_offset < 0)
		||(a_offset < 0)
		||(x_offset < 0)
		||(y_offset < 0)
		||(w_offset < 0)
		||(v_offset < 0)
		||(b_offset < 0))
	{
		// - ..
		return ERROR_FILE_NOT_FOUND;
	}

	_data.clear();
	_data.reserve(obj._data->NumInstances);

	perf_object_type::instance_iterator ii = obj.get_instance_iterator();

	//  
	while (ii.is_any())
	{
		perf_instance_definition instance = ii.get_next();

		Behemoth b = {0};

		b.name   = instance.name();
		b.mother = instance._data->ParentObjectInstance;

		memcpy(&(b.sex),      instance.get_counter_block() + s_offset, sizeof(DWORD));
		memcpy(&(b.age),      instance.get_counter_block() + a_offset, sizeof(DWORD));
		memcpy(&(b.x),        instance.get_counter_block() + x_offset, sizeof(DWORD));
		memcpy(&(b.y),        instance.get_counter_block() + y_offset, sizeof(DWORD));
		memcpy(&(b.weight),   instance.get_counter_block() + w_offset, sizeof(DWORD));
		memcpy(&(b.volume),   instance.get_counter_block() + v_offset, sizeof(DWORD));
		memcpy(&(b.birthday), instance.get_counter_block() + b_offset, sizeof(__int64));

		_data.push_back(b);
	}

	return ERROR_SUCCESS;
}

//  
//  FUNCTION:     int GetCount()
//
//  PARAMETERS:   
//
//  RETURN VALUE:  
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:        
//
//  COMMENTS:     
// 
int CBehemothLoader::GetCount() const
{
	return _data.size();
}

//  
//  FUNCTION:     const Behemoth* Get()
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:           
//
//  COMMENTS:     
// 
const Behemoth* CBehemothLoader::Get() const
{
	return &(_data[0]);
}

/////////////////////////////////////////////////////////////////
//
//  
//
/////////////////////////////////////////////////////////////////

//  
//  FUNCTION:     int LoadObject(CPerformanceData&, int , perf_object_type* )
//
//  PARAMETERS:   [IN]  pd    -  
//                [IN]  index -   
//                [OUT] obj   - 
//
//  RETURN VALUE:  
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:         
//
//  COMMENTS:     
// 
int CBehemothLoader::LoadObject(CPerformanceData& pd, int index, perf_object_type* obj)
{
	TCHAR text_index[10];

	wsprintf(text_index, TEXT("%d"), index);

	//  
	int res = pd.GoUser(text_index);

	if (res != ERROR_SUCCESS)
	{
		// -  
		return res;
	}

	perf_data_block block(pd.Get());
	perf_data_block::iterator bi = block.get_iterator();

	//       
	while (bi.is_any())
	{
		perf_object_type object = bi.get_next();

		if (object._data->ObjectNameTitleIndex == index)
		{
			//  
			*obj = object;
			return ERROR_SUCCESS;
		}
	}

	//  
	return ERROR_FILE_NOT_FOUND;
}

//  
//  FUNCTION:     int GetCounterOffset(const perf_object_type& , int )
//
//  PARAMETERS:   [IN] obj   - 
//                [IN] index -   
//
//  RETURN VALUE:      
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:            
//
//  COMMENTS:     
//
int CBehemothLoader::GetCounterOffset(const perf_object_type& obj, int index) const
{
	perf_object_type::counter_iterator ci = obj.get_counter_iterator();

	//   
	while (ci.is_any())
	{
		const PERF_COUNTER_DEFINITION* counter = ci.get_next();

		if (counter->CounterNameTitleIndex == index)
		{
			//  
			return counter->CounterOffset;
		}
	}	
	
	//  
	return -1;
}

/////////////////////////////////////////////////////////////////////////////