//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     behemothloader.h
//
//  PURPOSE:    ,      
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//

#ifndef BEHEMOTHLOADER_H
#define BEHEMOTHLOADER_H

#include "./perf/perfdata.h"
#include "./perf/perfobjects.h"
#include <vector>

struct Behemoth
{
	enum behemoth_sex
	{
		man   = 'm',
		woman = 'w'
	};

	const WCHAR* name;
	int mother;
	int sex;
	int age;
	int x;
	int y;
	int weight;
	int volume;
	__int64 birthday;
};

class CBehemothLoader
{
public:

	CBehemothLoader();
	~CBehemothLoader();

	//  ,  
	int Connect(const TCHAR* computer = NULL);

	//  
	int Load();

	//  
	int GetCount() const;

	//      
	const Behemoth* Get() const;

	bool IsConnected() const
	{
		return _behemoth_index > 0;
	}

private:

	int LoadObject(CPerformanceData& pd, int index, perf_object_type* obj);
	int GetCounterOffset(const perf_object_type& obj, int index) const;

private:

	int _behemoth_index;
	int _sex_index;
	int _age_index;
	int _x_index;
	int _y_index;
	int _weight_index;
	int _volume_index;
	int _birthday_index;

	CPerformanceData _loader;

	std::vector<Behemoth> _data;
};

#endif //BEHEMOTHLOADER_H