#ifndef OTHERDLG_H
#define OTHERDLG_H

#include "resource.h"

template<int idd>
class COtherDialog : public CDialogImpl<COtherDialog>
{
public:

	enum {IDD = idd};

	COtherDialog(int idc) : IDC(idc) {}

	BEGIN_MSG_MAP(COtherDialog)

		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)

		COMMAND_ID_HANDLER(IDCANCEL,   OnCancel)
		COMMAND_ID_HANDLER(IDOK,       OnOk)

	END_MSG_MAP()

	BOOL OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
	{
		s.Empty();
		return TRUE;
	}

	//  
	LRESULT OnOk(WORD, WORD, HWND, BOOL& b)
	{
		GetString(IDC, &s);
		EndDialog(1);
		return 1;
	}

	LRESULT OnCancel(WORD, WORD, HWND, BOOL& b)
	{
		EndDialog(0);
		return 1;
	}

	const TCHAR* get_s() {return s;}

private:

	void GetString(int id, CString* ps)
	{
		ps->Empty();
		
		HWND wnd = GetDlgItem(id);

		if (wnd == NULL)
		{
			return;
		}

		int count = CWindow(wnd).GetWindowTextLength() + 1;

		if (count <= 1)
		{
			return;
		}
				
		CWindow(wnd).GetWindowText(ps->GetBuffer(count), count);
		ps->ReleaseBuffer();
	}
	
	const int IDC;
	CString s;
};

#endif //OTHERDLG_H