//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Sample
//
//  MODULE:     com_support.cpp
//
//  PURPOSE:     ,    
//               COM. 
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows 9x/NT/2000/XP
//

#include "../stdafx.h"
#include "com_support.h"
#include "behemothserver.h"

//
//     -   .  , , . 
// , , .        
// " COM  DLL   ".
//    -   

#define SMART_USE_COM

namespace com_support
{
	//     -     ,
	//   
	HRESULT GetPointer(IBehemothariumData** pI, bool* init);

#ifdef SMART_USE_COM

	//
	//  ,    
	DWORD CALLBACK ComObjectsThread(LPVOID);

	CComPtr<IGlobalInterfaceTable> pGIT;
	DWORD magic = 0;

	HANDLE hCleanupEvent = NULL;
	HANDLE hComThread    = NULL;

#endif //SMART_USE_COM

}

////////////////////////////////////////////////////////////
//
//  
//
////////////////////////////////////////////////////////////

//  
//  FUNCTION:     long Init() 
//
//  PARAMETERS:   
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:      .  , . 
//
//  COMMENTS:        SMART_USE_COM,   .
//                  SMART_USE_COM,    DllMain 
// 
long com_support::Init()
{

#ifdef SMART_USE_COM

	hCleanupEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	if (!hCleanupEvent) 
	{
		//  
		return GetLastError();
	}

	DWORD id = GetCurrentThreadId();
	hComThread = CreateThread(NULL, 0, ComObjectsThread, (void*)id, 0, 0);

	if (!hComThread)
	{
		//  
		DWORD err = GetLastError();

		CloseHandle(hCleanupEvent);
		hCleanupEvent = NULL;
		
		return err;
	}

	MSG msg = {0};

	//   
	//     ,  
	//    Init   STA 
	//  InitCleanupThread     .
	//    ,     
	// ,   wParam
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	if (msg.wParam != ERROR_SUCCESS)
	{
		//   !

		//        
		//        AV. 
		// ,    ,   ,  
		//  dll    
		//  !   ....
		WaitForSingleObject(hComThread, INFINITE);

		CloseHandle(hCleanupEvent);
		hCleanupEvent = NULL;
		CloseHandle(hComThread);
		hComThread = NULL;

		return msg.wParam;
	}

#endif //SMART_USE_COM

	// !!!
	return ERROR_SUCCESS;
}

//  
//  FUNCTION:     void Cleanup() 
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:      .  , . 
//
//  COMMENTS:        SMART_USE_COM,   .
//                  SMART_USE_COM,    DllMain, 
//                    
// 
void com_support::Cleanup()
{

#ifdef SMART_USE_COM

	if (!hComThread) return;

	SetEvent(hCleanupEvent);

	if (WaitForSingleObject(hComThread, 10000) != WAIT_OBJECT_0)
	{
		//     DllMain,     
		// .         .
		TerminateThread(hComThread, 0);
	}

	CloseHandle(hComThread);
	CloseHandle(hCleanupEvent);

	hComThread = NULL;
	hCleanupEvent = NULL;

#endif //SMART_USE_COM

}

//  
//  FUNCTION:     HRESULT Get(SAFEARRAY**)
//
//  PARAMETERS:   [OUT] psa - safearay 
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:        ,  . 
//
//  COMMENTS:     
// 
HRESULT com_support::Get(SAFEARRAY** psa)
{
	HRESULT hr;
	bool init;
	CComPtr<IBehemothariumData> pServ; 
	
	hr = GetPointer(&pServ, &init);

	if (FAILED(hr))
	{
		return hr;
	}

	hr = pServ->Get(psa);

	pServ.Release();

	if (init)
	{
		CoUninitialize();
	}

	return hr;
}

//  
//  FUNCTION:     HRESULT GetSummary(long* , long* )
//
//  PARAMETERS:   [OUT] count  -   
//                [OUT] weight -   
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:        ,  . 
//
//  COMMENTS:     
// 
HRESULT com_support::GetSummary(long* count, long* weight)
{
	HRESULT hr;
	bool init;
	CComPtr<IBehemothariumData> pServ; 
	
	hr = GetPointer(&pServ, &init);

	if (FAILED(hr))
	{
		return hr;
	}

	hr = pServ->GetSummary(count, weight);

	pServ.Release();

	if (init)
	{
		CoUninitialize();
	}

	return hr;
}

////////////////////////////////////////////////////////////
//
//  
//
////////////////////////////////////////////////////////////

//    SMART_USE_COM,     
#ifdef SMART_USE_COM

//  
//  FUNCTION:     DWORD CALLBACK ComObjectsThread(LPVOID )
//
//  PARAMETERS:   [IN/OUT] id - id -
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:       ,   
//                   
//
//  COMMENTS:     
// 
DWORD CALLBACK com_support::ComObjectsThread(LPVOID param)
{
	DWORD id = (DWORD)param;
	HRESULT hr;

	CoInitializeEx(0, COINIT_MULTITHREADED);

	CComPtr<IBehemothariumData> pBehemoth;

	//  
	hr = pBehemoth.CoCreateInstance(__uuidof(BehemothariumObj));

	if (FAILED(hr))
	{
		CoUninitialize();
		PostThreadMessage(id, WM_QUIT, hr, 0);
		return 0;
	}

	//    GIT
	hr = pGIT.CoCreateInstance(CLSID_StdGlobalInterfaceTable);

	if (FAILED(hr))
	{
		pBehemoth.Release();
		CoUninitialize();
		PostThreadMessage(id, WM_QUIT, hr, 0);
		return 0;
	}
	
	//    
	hr = pGIT->RegisterInterfaceInGlobal(pBehemoth, __uuidof(IBehemothariumData), &magic);

	//    
	pBehemoth.Release();

	if (FAILED(hr))
	{
		pGIT.Release();
		CoUninitialize();
		PostThreadMessage(id, WM_QUIT, hr, 0);
		return 0;
	}

	//   
	PostThreadMessage(id, WM_QUIT, ERROR_SUCCESS, 0);

	//  
	WaitForSingleObject(hCleanupEvent, INFINITE);

	// , .
	pGIT->RevokeInterfaceFromGlobal(magic);
	pGIT.Release();
	
	CoUninitialize();

	return 0; 
}

#endif //SMART_USE_COM

//  
//  FUNCTION:     HRESULT GetPointer(IBehemothariumDP** , bool* )
//
//  PARAMETERS:   [OUT] pI -  
//                [OUT] pI -      CoUninitialize
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:         
//
//  COMMENTS:        ,   . 
// 
HRESULT com_support::GetPointer(IBehemothariumData** pI, bool* init)
{
	HRESULT hr = CoInitializeEx(0, COINIT_MULTITHREADED);

	if (hr == RPC_E_CHANGED_MODE)
	{
		*init = false;
	}
	else
	{
		*init = true;
	}

#ifdef SMART_USE_COM

	hr = pGIT->GetInterfaceFromGlobal(magic, __uuidof(IBehemothariumData), (void**)pI);

#else //SMART_USE_COM

	hr = CoCreateInstance(
				__uuidof(BehemothariumObj), 
				NULL, 
				CLSCTX_ALL,
				__uuidof(IBehemothariumData),
				(void**)pI);

#endif //SMART_USE_COM  

	if (FAILED(hr) && *init)
	{
		CoUninitialize();
		*init = false;
	}

	return hr;	
}
///////////////////////////////////////////////////////////
