//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Sample
//
//  MODULE:     cache.cpp
//
//  PURPOSE:     ,   
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows 9x/NT/2000/XP
//

#include "stdafx.h"
#include "./com/com_support.h"
#include "./com/safearray.h"
#include "./com/behemothserver.h"
#include "cache.h"

namespace cache
{
	CComSafeVector<Behemoth> sa;

	long count = 0;
	long weight = 0;

	DWORD summary_time = 0;
	DWORD array_time = 0;

	//   
	const DWORD cache_time = 100;
}

//  
//  FUNCTION:     void Cleanup() 
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:      
//
//  COMMENTS:     ,    ..
// 
void cache::Cleanup()
{
	sa.Destroy();
}

//  
//  FUNCTION:     HRESULT GetSummary() 
//
//  PARAMETERS:   
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:           cache_time,
//                     GetSummary
//
//  COMMENTS:     
// 
HRESULT cache::GetSummary()
{
	if (summary_time + cache_time > GetTickCount())
	{
		return S_OK;
	}

	HRESULT hr = com_support::GetSummary(&count, &weight);

	if (FAILED(hr))
	{
		return hr;
	}

	if (count > sa.size())
	{
		//     
		array_time = 0;
	}

	summary_time = GetTickCount();
	return S_OK;
}

//  
//  FUNCTION:     HRESULT GetArray() 
//
//  PARAMETERS:   
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:           cache_time,
//                     Get
//
//  COMMENTS:         GetSummary
// 
HRESULT cache::GetArray()
{
	if (array_time + cache_time > GetTickCount())
	{
		return S_OK;
	}

	sa.Destroy();

	HRESULT hr = com_support::Get(&sa);

	if (FAILED(hr))
	{
		return hr;
	}

	sa.BoundsChanged();
	sa.AccessData();

	count = sa.size();
	weight = 0;

	for (int i = 0; i < count; i++)
	{
		weight += sa[i].weight;
	}

	summary_time = GetTickCount();
	array_time = summary_time;

	return S_OK;
}

//  
//  FUNCTION:     DWORD GetCount() 
//
//  PARAMETERS:   
//
//  RETURN VALUE:  
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:      
//
//  COMMENTS:     
// 
DWORD cache::GetCount()
{
	return count;
}

//  
//  FUNCTION:     DWORD GetWeight() 
//
//  PARAMETERS:   
//
//  RETURN VALUE:   
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:      
//
//  COMMENTS:     
// 
DWORD cache::GetWeight()
{
	return weight;
}

//  
//  FUNCTION:     DWORD Get(int) 
//
//  PARAMETERS:   [IN] i - 
//
//  RETURN VALUE: 
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:         
//
//  COMMENTS:     
// 
const Behemoth& cache::Get(int i)
{
	ATLASSERT(i >= 0);
	ATLASSERT(i < count);

	if (i >= sa.size())
	{
		static Behemoth empty = {0};
		return empty;
	}

	return sa[i];
}

/////////////////////////////////////////////////////////////