//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Sample
//
//  MODULE:     main.cpp
//
//  PURPOSE:       . 
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//

#include "stdafx.h"
#include "registry.h"
#include "perf_impl.h"

///////////////////////////////////////////////////////
//
//  dll 
//
//////////////////////////////////////////////////////

extern "C" __declspec(dllexport) DWORD CALLBACK Open(LPWSTR lpDeviceNames)
{
	return perf_impl::Open();
}

//
//    Collect  perf_impl 
// ,      
extern "C" __declspec(dllexport) DWORD WINAPI Collect(
											LPWSTR lpwszValue, 
											LPVOID *lppData, 
											LPDWORD lpcbBytes, 
											LPDWORD lpcObjectTypes)
{
	void* data = *lppData;
	DWORD size = *lpcbBytes;
	DWORD bytes;
	DWORD objects;

	DWORD res = perf_impl::Collect(lpwszValue, data, size, &bytes, &objects);

	if (res != ERROR_SUCCESS)
	{
		*lpcbBytes = 0;
		*lpcObjectTypes = 0;
		return res;
	}

	*lppData = (char*)data + bytes;
	*lpcbBytes = bytes;
	*lpcObjectTypes = objects;

	return ERROR_SUCCESS;
}

extern "C" __declspec(dllexport) DWORD WINAPI Close()
{
	perf_impl::Close();
	return ERROR_SUCCESS;
}

///////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////

HINSTANCE hInst = 0;

STDAPI DllRegisterServer()
{
	return Registry::DllRegister((HMODULE)hInst);
}

STDAPI DllUnregisterServer()
{
	return Registry::DllUnregister();
}

BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD reason, LPVOID)
{
	if (reason == DLL_PROCESS_ATTACH)
	{
		hInst = hInstance;
	}
	else if (reason == DLL_PROCESS_DETACH)
	{
		perf_impl::FinalClose();
	}

	return TRUE;
}

///////////////////////////////////////////////////////