//
//  Copyright (C) 2003, .
//
//  PROJECT:    
//
//  MODULE:     mainwnd.cpp
//
//  PURPOSE:       
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows 2000/XP/NT/9x
//
//  CLASSES:  
//       CMainWnd
//

#include "stdwtl.h"
#include "mainwnd.h"
#include "waitcursor.h"
#include "message.h"
#include "createdlg.h"

//////////////////////////////////////////////////////////////////////
//
//  CMainWindow
//
//////////////////////////////////////////////////////////////////////

//  
//  FUNCTION:     CMainWindow(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:      .    
//                   
//
//  COMMENTS:     
//
CMainWindow::CMainWindow() : _go(false)
{
	GetWndClassInfo().m_wc.hbrBackground = (HBRUSH)GetStockObject(NULL_BRUSH);
	GetWndClassInfo().m_wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
	GetWndClassInfo().m_wc.hIcon         = NULL;
	GetWndClassInfo().m_wc.hIconSm       = GetWndClassInfo().m_wc.hIcon;
}

//  
//  FUNCTION:     ~CMainWindow(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:      . 
//
//  COMMENTS:     
//
CMainWindow::~CMainWindow()
{
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

//  
//  FUNCTION:     LRESULT OnCreate(CREATESTRUCT*)
//
//  PARAMETERS:   [IN] cs -   
//
//  RETURN VALUE: 0  -  
//                -1 -   
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:        
//
//  COMMENTS:     
//
LRESULT CMainWindow::OnCreate(CREATESTRUCT* cs)
{
	_splitter.Create(
				*this, 
				rcDefault, 
				NULL, 
				WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
				0);

	_splitter.m_cxySplitBar /= 2;

	if (_tree.Create(_splitter) && _view.Create(_splitter)) 
	{
		_splitter.SetSplitterPanes(_tree, _view);

		RECT rc = {0, 0, 100, 100};
		_splitter.SetSplitterRect(&rc);
		_splitter.SetSplitterPos(30);

		SetTimer(1, 100);

		return 0;
	}
	
	return -1;
}

//  
//  FUNCTION:     void OnSize(UINT, CSize)
//
//  PARAMETERS:   [IN] type -  
//                [IN] s    -  
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:           
//                   .
//
//  COMMENTS:     
//
void CMainWindow::OnSize(UINT, CSize s)
{
	_splitter.MoveWindow(0, 0, s.cx, s.cy);
}

//  
//  FUNCTION:     void OnClose(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:       .
//
//  COMMENTS:     
//
void CMainWindow::OnClose()
{
	SetMsgHandled(FALSE);
}

void CMainWindow::OnInitMenu(HMENU hMenu, UINT, BOOL)
{
	if (!_data.IsConnected())
	{
		EnableMenuItem(hMenu, ID_GO, MF_BYCOMMAND | MF_ENABLED);

		EnableMenuItem(hMenu, ID_CREATE, MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(hMenu, ID_KILL,   MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(hMenu, ID_PAUSE,  MF_BYCOMMAND | MF_GRAYED);

		return;
	}

	DWORD enable_1 = MF_BYCOMMAND;
	DWORD enable_2 = MF_BYCOMMAND;

	if (_go)
	{
		enable_1 |= MF_GRAYED;
		enable_2 |= MF_ENABLED;
	}
	else
	{
		enable_1 |= MF_ENABLED;
		enable_2 |= MF_GRAYED;
	}

	EnableMenuItem(hMenu, ID_GO,     enable_1);
	EnableMenuItem(hMenu, ID_CREATE, enable_1);
	EnableMenuItem(hMenu, ID_KILL,   enable_1);

	EnableMenuItem(hMenu, ID_PAUSE,  enable_2);
}

//  
//  FUNCTION:     void OnDestroy(void)
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     19.07.2002   
//
//  PURPOSE:       .
//
//  COMMENTS:     
//
void CMainWindow::OnDestroy()
{
	PostQuitMessage(0);
}

void CMainWindow::OnTimer(UINT id, TIMERPROC*)
{
	if (!_go) return;

	if (!LoadData(false))
	{
		_go = false;
	}
}

//////////////////////////////////////////////////////////////
//
//   
//
//////////////////////////////////////////////////////////////

void CMainWindow::OnGo(UINT code, int id, HWND hCtrl)
{
	if (!_data.IsConnected())
	{
		int res;

		{
			CWaitCursor wc;
			res = _data.Connect();
		}

		if (res != 0)
		{
			message::format_error(*this, IDS_E_CONNECT, res);
			return;
		}
	}
	else
	{
		_data.Continue();
	}

	_go = true;
	_tree.Clear();
}

void CMainWindow::OnPause(UINT code, int id, HWND hCtrl)
{
	if (!_data.IsConnected()) return;

	_go = false;

	_data.Pause();

	LoadData(true);
}

void CMainWindow::OnCreate(UINT code, int id, HWND hCtrl)
{
	if (!_data.IsConnected()) return;
	if (_go) return;

	CCreateDialog cd;

	if (!cd.DoModal())
	{
		return;
	}

	_data.Create(cd.get_name(), cd.get_sex());
	LoadData(true);
}

void CMainWindow::OnKill(UINT code, int id, HWND hCtrl)
{
	if (!_data.IsConnected()) return;
	if (_go) return;

	int index = _tree.GetCurrentItem();

	if (index < 0) return;

	if (message::question(m_hWnd, IDS_Q_KILL))
	{
		_data.Kill(index);
		LoadData(true);
	}
}

void CMainWindow::OnExit(UINT code, int id, HWND hCtrl)
{
	SendMessage(WM_CLOSE, 0);
}

void CMainWindow::OnAbout(UINT code, int id, HWND hCtrl)
{
	CSimpleDialog<IDD_ABOUT> a;
	a.DoModal();
}

//////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////

LRESULT CMainWindow::OnTreeSetChange(LPNMHDR nmhdr)
{
	if (_go) return 0; 

	_view.Redraw(_data.GetCount(), _data.Get(), _tree.GetCurrentItem());
	return 0;
}

///////////////////////////////////////////////////////////
//
//  
//
///////////////////////////////////////////////////////////

bool CMainWindow::LoadData(bool tree)
{
	int res = _data.Load();

	if (res != 0)
	{
		message::format_error(*this, IDS_E_LOAD, res);
		return false;
	}

	_view.Redraw(_data.GetCount(), _data.Get());

	if (tree)
	{
		_tree.Fill(_data.GetCount(), _data.Get());
	}

	return true;
}

///////////////////////////////////////////////////////////
