//
//  Copyright (C) 2002, AstroSoft Ltd. All Rights Reserved.
//
//  PROJECT:    Logon Manager
//
//  MODULE:     mainwnd.h
//
//  PURPOSE:       
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows 2000/XP/NT/9x
//
//  CLASSES:  
//       CMainWindow
//

#ifndef MAINWND_H
#define MAINWND_H

#include "resource.h"
#include <atlsplit.h>
#include "behemothmanager.h"
#include "behemothtree.h"
#include "behemothview.h"

class CMainWindow : public CWindowImpl<CMainWindow, CWindow, CFrameWinTraits>
{
public:
	CMainWindow();
	~CMainWindow();

	//       .
	BEGIN_MSG_MAP_EX(CMainWindow)

		MSG_WM_CREATE(OnCreate)
		MSG_WM_SIZE(OnSize)
		MSG_WM_CLOSE(OnClose)
		MSG_WM_DESTROY(OnDestroy)
		MSG_WM_INITMENUPOPUP(OnInitMenu);
		MSG_WM_TIMER(OnTimer)
		
		COMMAND_ID_HANDLER_EX(ID_GO,     OnGo)
		COMMAND_ID_HANDLER_EX(ID_PAUSE,  OnPause)

		COMMAND_ID_HANDLER_EX(ID_CREATE, OnCreate)
		COMMAND_ID_HANDLER_EX(ID_KILL,   OnKill)
		
		COMMAND_ID_HANDLER_EX(ID_EXIT,   OnExit)
		COMMAND_ID_HANDLER_EX(ID_ABOUT,  OnAbout)

		NOTIFY_CODE_HANDLER_EX(TVN_SELCHANGED, OnTreeSetChange);

	END_MSG_MAP()

	//  
	LRESULT OnCreate(CREATESTRUCT* cs);
	void OnSize(UINT type, CSize s);
	void OnClose();
	void OnDestroy();
	void OnInitMenu(HMENU hMenu, UINT, BOOL);
	void OnTimer(UINT id, TIMERPROC*);
	
	// 
	void OnGo(UINT code, int id, HWND hCtrl);
	void OnPause(UINT code, int id, HWND hCtrl);
	void OnCreate(UINT code, int id, HWND hCtrl);
	void OnKill(UINT code, int id, HWND hCtrl);
	void OnExit(UINT code, int id, HWND hCtrl);

	void OnAbout(UINT code, int id, HWND hCtrl);

	//  
	LRESULT OnTreeSetChange(LPNMHDR nmhdr);

private:

	bool LoadData(bool tree);

private:

	CSplitterWindow _splitter;
	CBehemothsTree  _tree;
	CBehemothsView  _view;

	CBehemothManager _data;

	bool            _go;
};

#endif //MAINWND_H