//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     behemothmanager.cpp
//
//  PURPOSE:    ,       
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//

#include "stdwtl.h"
#include "behemothmanager.h"

////////////////////////////////////////////////////////////////////
//
//  
//
//////////////////////////////////////////////////////////////////////

CBehemothManager::CBehemothManager()
{
}

CBehemothManager::~CBehemothManager()
{
	_data.Destroy();
	_loader.Release();
	_manager.Release();
	CoUninitialize();
}

//  
//  FUNCTION:     int Connect()
//
//  PARAMETERS:   
//
//  RETURN VALUE:   
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:         ,  
//                   .   NULL   , 
//                   .
//
//  COMMENTS:     
// 
int CBehemothManager::Connect()
{
	if (_loader) return 0;

	CoInitialize(0);

	HRESULT hr;

	hr = _loader.CoCreateInstance(__uuidof(BehemothariumObj));

	if (FAILED(hr))
	{
		return hr;
	}

	hr = _manager.CoCreateInstance(__uuidof(BehemothariumObj));

	if (FAILED(hr))
	{
		_loader.Release();
		return hr;
	}

	return S_OK;
}

//  
//  FUNCTION:     int Load()
//
//  PARAMETERS:   
//
//  RETURN VALUE:   
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:       ,  ,   
//
//  COMMENTS:     
// 
int CBehemothManager::Load()
{
	_ASSERT(_loader);

	HRESULT hr;
	SAFEARRAY* sa;

	hr = _loader->Get(&sa);

	if (FAILED(hr))
	{
		return hr;
	}

	_data.Attach(sa);
	_data.AccessData();

	return ERROR_SUCCESS;
}

//  
//  FUNCTION:     int GetCount()
//
//  PARAMETERS:   
//
//  RETURN VALUE:  
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:        
//
//  COMMENTS:     
// 
int CBehemothManager::GetCount() const
{
	return _data.size();
}

//  
//  FUNCTION:     const Behemoth* Get()
//
//  PARAMETERS:   
//
//  RETURN VALUE: 
//
//  REVISION:     17.08.2003   
//
//  PURPOSE:           
//
//  COMMENTS:     
// 
const Behemoth* CBehemothManager::Get() const
{
	return &(_data[0]);
}

void CBehemothManager::Pause()
{
	_manager->Pause();
}

void CBehemothManager::Continue()
{
	_manager->Continue();
}

void CBehemothManager::Create(const TCHAR* name, int sex)
{
	CComBSTR str = name;

	_manager->Create(str, sex);
}

void CBehemothManager::Kill(int index)
{
	_manager->Kill(index);
}

/////////////////////////////////////////////////////////////////////////////