#ifndef BEHEMOTHVIEW_H
#define BEHEMOTHVIEW_H

class CBehemothsView : public CWindowImpl<CBehemothsView, CWindow, CControlWinTraits>
{
public:

	typedef CWindowImpl<CBehemothsView, CWindow, CControlWinTraits> CBase;

	CBehemothsView() 
	{
		GetWndClassInfo().m_wc.hbrBackground = GetBackgroundBrush();
	}

	~CBehemothsView() {}

	HWND Create(HWND hParent);

	BEGIN_MSG_MAP_EX(CBehemothsView)

		MSG_WM_PAINT(OnPaint)
		MSG_WM_ERASEBKGND(OnErase)
		MSG_WM_SIZE(OnSize)

	END_MSG_MAP()

	void OnPaint(HDC);
	LRESULT OnErase(HDC hdc);

	void OnSize(UINT, CSize s);

	void Redraw(int size, const Behemoth* data, int selected = -1);

private:

	void RedrawBitmap(int size, const Behemoth* data, int selected);
	void CalculateRect(const Behemoth& data, RECT* rc);

	static HBRUSH GetBackgroundBrush();
	static HBRUSH GetManBrush();
	static HBRUSH GetWomanBrush();
	static HPEN   GetWomanPen();
	static HBRUSH GetSelectBrush();
	static HPEN   GetSelectPen();


	CBitmap bitmap;
	CDC     memdc;
	int     wnd_size_x;
	int     wnd_size_y;

	int     bmp_size_x;
	int     bmp_size_y;
};

#endif //BEHEMOTHS_VIEW_H