// Behemotharium_obj.cpp : Implementation of CBehemotharium
#include "stdafx.h"
#include "Behemothserver.h"
#include "Behemotharium_obj.h"
#include "Behemotharium.h"
#include "safearray.h"

struct DECLSPEC_UUID("B39A8AB1-5B4D-440b-BB9E-39DB3F548479") Behemoth_struct;

/////////////////////////////////////////////////////////////////////////////
// CBehemotharium


///////////////////////////////////////////////////////////
//
//  IBehemothariumData
// 
/////////////////////////////////////////////////////////

STDMETHODIMP CBehemothariumObj::GetSummary(long *count, long *weight)
{
	Behemotharium::Lock();

	*count  = Behemotharium::GetCount();
	*weight = Behemotharium::GetWeight();

	Behemotharium::Unlock();

	return S_OK;
}

STDMETHODIMP CBehemothariumObj::Get(SAFEARRAY **psa)
{
	CComSafeVector<Behemoth> b;

	Behemotharium::Lock();

	int count = Behemotharium::GetCount();

	b.CreateEx(__uuidof(Behemoth_struct), LIBID_BEHEMOTHSERVERLib, 1, 0, 0, count);

	b.AccessData();

	for (int i = 0; i < b.size(); i++)
	{
		Behemotharium::Behemoth bh;

		Behemotharium::Get(i, &bh);

		b[i].name     = SysAllocString(bh.name);
		b[i].mother   = bh.mother;
		b[i].sex      = bh.sex;
		b[i].age      = bh.age;
		b[i].x        = bh.x;
		b[i].y        = bh.y;
		b[i].weight   = bh.weight;
		b[i].volume   = bh.volume;
		b[i].birthday = bh.birthday;
	}

	b.UnaccessData();

	Behemotharium::Unlock();

	*psa = b.Detach();
	
	return S_OK;
}

///////////////////////////////////////////////////////////
//
//  IBehemothariumManager
// 
/////////////////////////////////////////////////////////

STDMETHODIMP CBehemothariumObj::Create(BSTR name, long sex)
{
	Behemotharium::Lock();

	Behemotharium::Create(name, sex);

	Behemotharium::Unlock();

	return S_OK;
}

STDMETHODIMP CBehemothariumObj::Kill(LONG index)
{
	Behemotharium::Lock();

	Behemotharium::Kill(index);

	Behemotharium::Unlock();

	return S_OK;
}

STDMETHODIMP CBehemothariumObj::Pause()
{
	Behemotharium::Pause();
	return S_OK;
}

STDMETHODIMP CBehemothariumObj::Continue()
{
	Behemotharium::Continue();
	return S_OK;
}

/////////////////////////////////////////////////////////
