#include <windows.h>   
#include "offset.h"    //      
#include "registry.h"  //       .  
                       //  -   "First Counter"  "First Help"   
                       //     .

PERF_OBJECT_TYPE        type     = {0};
PERF_COUNTER_DEFINITION counter1 = {0};
PERF_COUNTER_DEFINITION counter2 = {0};
PERF_COUNTER_BLOCK      bl       = {0};

const WCHAR* hw = L"Hello, World!";

//  v    8 
DWORD UpTo8(DWORD v)
{
	if (v % 8)
	{
		v += 8;
		v -= v % 8;
	}

	return v;
}

//
//   ,   .
extern "C" __declspec(dllexport) DWORD CALLBACK Open(LPWSTR lpDeviceNames)
{
	DWORD name;
	DWORD help;

	//  ,   "First Counter"  "First Help"
	DWORD res = Registry::GetFirst(&name, &help);
	if (res != ERROR_SUCCESS)
	{
		//  . ,   .
		return res;
	}

	PERF_COUNTER_TEXT;

	//   .     .
	type.ObjectNameTitleIndex  = name + TYPE_OFFSET;
	type.ObjectHelpTitleIndex  = help + TYPE_OFFSET;
	type.NumCounters           = 2;                   //  
	type.NumInstances          = PERF_NO_INSTANCES;   //  
	type.HeaderLength          = sizeof(type);
	
	//    
	counter1.CounterNameTitleIndex = name + COUNTER1_OFFSET;
	counter1.CounterHelpTitleIndex = help + COUNTER1_OFFSET;
	counter1.CounterSize           = (lstrlenW(hw) + 1) * sizeof(WCHAR);
	counter1.CounterType           = PERF_SIZE_VARIABLE_LEN | PERF_TYPE_TEXT | PERF_TEXT_UNICODE;
	counter1.CounterOffset         = sizeof(bl);
	counter1.ByteLength            = sizeof(counter1);

	//    
	counter2.CounterNameTitleIndex = name + COUNTER2_OFFSET;
	counter2.CounterHelpTitleIndex = help + COUNTER2_OFFSET;
	counter2.CounterSize           = sizeof(DWORD);
	counter2.CounterType           = PERF_SIZE_DWORD | PERF_TYPE_NUMBER;
	counter2.CounterOffset         = counter1.CounterOffset + counter1.CounterSize; //    
	counter2.ByteLength            = sizeof(counter2);

	//         
	bl.ByteLength = counter2.CounterOffset + counter2.CounterSize;

	type.DefinitionLength = type.HeaderLength + counter1.ByteLength + counter2.ByteLength;

	//      8 .   EventLog  ,
	//        dll..
	type.TotalByteLength  = UpTo8(type.DefinitionLength + bl.ByteLength);
	
	return ERROR_SUCCESS;
}

//
//    .    
// ,     .
extern "C" __declspec(dllexport) DWORD WINAPI Collect(
								LPWSTR lpwszValue, 
								LPVOID *lppData, 
								LPDWORD lpcbBytes, 
								LPDWORD lpcObjectTypes)
{
	if (*lpcbBytes < type.TotalByteLength)
	{
		//  
		*lpcbBytes = 0;
		*lpcObjectTypes = 0;
		return ERROR_MORE_DATA;
	}

	char* temp = (char*)(*lppData);

	//   
	memcpy(temp, &type, sizeof(type));
	temp += type.HeaderLength;

	//    
	memcpy(temp, &counter1, sizeof(counter1));
	temp += counter1.ByteLength;

	//    
	memcpy(temp, &counter2, sizeof(counter2));
	temp += counter2.ByteLength;

	//    
	memcpy(temp, &bl, sizeof(bl));

	//    
	memcpy(temp + counter1.CounterOffset, hw, (lstrlenW(hw) + 1) * sizeof(WCHAR));

	DWORD v = rand() % 10;

	//    
	memcpy(temp + counter2.CounterOffset, &v, sizeof(DWORD));

	//   
	*lppData        = (char*)(*lppData) + type.TotalByteLength;
	*lpcbBytes      = type.TotalByteLength;
	*lpcObjectTypes = 1;

	return ERROR_SUCCESS;
}

extern "C" __declspec(dllexport) DWORD WINAPI Close()
{
	return ERROR_SUCCESS;
}

/////////////////////////////////////
//
//  
//
/////////////////////////////////////

HINSTANCE hInst = 0;

STDAPI DllRegisterServer()
{
	return Registry::DllRegister((HMODULE)hInst);
}

STDAPI DllUnregisterServer()
{
	return Registry::DllUnregister();
}

BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD reason, LPVOID)
{
	if (reason == DLL_PROCESS_ATTACH)
	{
		hInst = hInstance;
	}

	return TRUE;
}

///////////////////////////////////////////////////////