#include <windows.h>   
#include "offset.h"    //      
#include "registry.h"  //       . 
                       //    -   "First Counter"
                       //  "First Help"   .
                       //     .
#include "data_provider.h" // ,  . 
                           //   Data.   .

PERF_OBJECT_TYPE         type     = {0};
PERF_COUNTER_DEFINITION  counter  = {0};
PERF_INSTANCE_DEFINITION instance = {0};
PERF_COUNTER_BLOCK       bl       = {0};

//  v    8 
DWORD UpTo8(DWORD v)
{
	if (v % 8)
	{
		v += 8;
		v -= v % 8;
	}

	return v;
}

//
//   ,   .
extern "C" __declspec(dllexport) DWORD CALLBACK Open(LPWSTR lpDeviceNames)
{
	DWORD name;
	DWORD help;

	//  ,   "First Counter"  "First Help"
	DWORD res = Registry::GetFirst(&name, &help);
	if (res != ERROR_SUCCESS)
	{
		//  . ,   .
		return res;
	}

	//   .    
    //    Collect
	type.ObjectNameTitleIndex  = name + TYPE_OFFSET;
	type.ObjectHelpTitleIndex  = help + TYPE_OFFSET;
	type.NumCounters           = 1;
	type.HeaderLength          = sizeof(type);
	type.CodePage              = 0;               //    unicode
	
	//   
	counter.CounterNameTitleIndex = name + COUNTER_OFFSET;
	counter.CounterHelpTitleIndex = help + COUNTER_OFFSET;
	counter.CounterSize           = sizeof(DWORD);
	counter.CounterType           = PERF_SIZE_DWORD | PERF_TYPE_NUMBER;
	counter.CounterOffset         = sizeof(bl);
	counter.ByteLength            = sizeof(counter);

	//   
	//       .
	instance.ParentObjectTitleIndex = 0;
	instance.ParentObjectInstance   = 0;
	instance.UniqueID               = PERF_NO_UNIQUE_ID;
	instance.NameOffset             = sizeof(instance);

	//   
	bl.ByteLength = counter.CounterOffset + counter.CounterSize;
	
	type.DefinitionLength = type.HeaderLength + counter.ByteLength;

	return ERROR_SUCCESS;
}

//
//    .    
// ,     .
extern "C" __declspec(dllexport) DWORD WINAPI Collect(
								LPWSTR lpwszValue, 
								LPVOID *lppData, 
								LPDWORD lpcbBytes, 
								LPDWORD lpcObjectTypes)
{
	char* temp = (char*)(*lppData);
	int size = type.DefinitionLength;

	//   
	int count = Data::get_instances_count();

	// -       
	//     .   .

	for (int i = 0; i < count;i++)
	{
		WCHAR* name = 0;
		int    name_len = 0;
		//     .     malloc-
		Data::get_name(i, &name, &name_len);
		//   -  ;    
		// , Performance  
		instance.NameLength = (name_len + 1) * sizeof(WCHAR);
		instance.ByteLength = instance.NameOffset + instance.NameLength;

		if (UpTo8(size + instance.ByteLength + bl.ByteLength) > *lpcbBytes)
		{
			//  
			free(name);
			*lpcbBytes = 0;
			*lpcObjectTypes = 0;
			return ERROR_MORE_DATA;
		}

		//   
		memcpy(temp + size, &instance, sizeof(instance));
		//   
		memcpy(temp + size + instance.NameOffset, name, instance.NameLength);

		size += instance.ByteLength;

		//   PERF_COUNTER_BLOCK
		memcpy(temp + size, &bl, sizeof(bl));

		//  
		DWORD data = Data::get_data(i);

		//  
		memcpy(temp + size + counter.CounterOffset, &data, sizeof(data));

		size += bl.ByteLength;

		free(name);
	}

	type.NumInstances = count;
	type.TotalByteLength = UpTo8(size);

	//   
	memcpy(temp, &type, sizeof(type));
	
	//   
	memcpy(temp + type.HeaderLength, &counter, sizeof(counter));

	//   
	*lppData        = (char*)(*lppData) + type.TotalByteLength;
	*lpcbBytes      = type.TotalByteLength;
	*lpcObjectTypes = 1;

	return ERROR_SUCCESS;
}

extern "C" __declspec(dllexport) DWORD WINAPI Close()
{
	return ERROR_SUCCESS;
}


/////////////////////////////////////
//
//  
//
/////////////////////////////////////

HINSTANCE hInst = 0;

STDAPI DllRegisterServer()
{
	return Registry::DllRegister((HMODULE)hInst);
}

STDAPI DllUnregisterServer()
{
	return Registry::DllUnregister();
}

BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD reason, LPVOID)
{
	if (reason == DLL_PROCESS_ATTACH)
	{
		hInst = hInstance;
	}

	return TRUE;
}

///////////////////////////////////////////////////////