#include <windows.h>
#include "offset.h"
#include "registry.h"
#include "./perf/perf_objects.h"

perf::object_type_single type(TYPE_OFFSET);

const WCHAR* hw = L"Hello, World! (smart version)";

extern "C" __declspec(dllexport) DWORD CALLBACK Open(LPWSTR lpDeviceNames)
{
	DWORD name;
	DWORD help;

	Registry::GetFirst(&name, &help);

	perf::base_name_index = name;
	perf::base_help_index = help;

	if (type.get_counters_count() == 0)
	{
		//    Open.   ..
		type.add_counter(
					COUNTER1_OFFSET, 
					PERF_SIZE_VARIABLE_LEN | PERF_TYPE_TEXT | PERF_TEXT_UNICODE, 
					(lstrlenW(hw) + 1) * sizeof(WCHAR));

		type.add_counter(
					COUNTER2_OFFSET, 
					PERF_SIZE_DWORD | PERF_TYPE_NUMBER);
	}

	return ERROR_SUCCESS;
}

extern "C" __declspec(dllexport) DWORD WINAPI Collect(
											LPWSTR lpwszValue, 
											LPVOID *lppData, 
											LPDWORD lpcbBytes, 
											LPDWORD lpcObjectTypes)
{
	int total_size = type.get_total_length();

	if (*lpcbBytes < total_size)
	{
		*lpcbBytes = 0;
		*lpcObjectTypes = 0;
		return ERROR_MORE_DATA;
	}

	type.set_buffer(*lppData);

	type.write_header();
	type.write_counter(0, hw, (lstrlenW(hw) + 1) * sizeof(WCHAR));
	type.write_counter(1, 20 + rand() % 10);

	*lppData        = (char*)(*lppData) + total_size;
	*lpcbBytes      = total_size;
	*lpcObjectTypes = 1;

	return ERROR_SUCCESS;
}

extern "C" __declspec(dllexport) DWORD WINAPI Close()
{
	return ERROR_SUCCESS;
}

/////////////////////////////////////
//
//  
//
/////////////////////////////////////

HINSTANCE hInst = 0;

STDAPI DllRegisterServer()
{
	return Registry::DllRegister((HMODULE)hInst);
}

STDAPI DllUnregisterServer()
{
	return Registry::DllUnregister();
}

BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD reason, LPVOID)
{
	if (reason == DLL_PROCESS_ATTACH)
	{
		hInst = hInstance;
	}

	return TRUE;
}

///////////////////////////////////////////////////////