#include <windows.h> 
#include "./perf/perf_objects.h" 
#include "offset.h"    
#include "registry.h"  
#include "data_provider.h" 

perf::object_type_instance type(TYPE_OFFSET);

//
//   ,   .
extern "C" __declspec(dllexport) DWORD CALLBACK Open(LPWSTR lpDeviceNames)
{
	DWORD name;
	DWORD help;

	DWORD res = Registry::GetFirst(&name, &help);

	if (res != ERROR_SUCCESS)
	{
		//  . ,   .
		return res;
	}

	perf::base_name_index = name;
	perf::base_help_index = help;

	if (type.get_counters_count() == 0)
	{
		//    Open.   ..
		type.add_counter(COUNTER_OFFSET, PERF_SIZE_DWORD | PERF_TYPE_NUMBER);
	}

	return ERROR_SUCCESS;
}

//
//    .    
// ,     .
extern "C" __declspec(dllexport) DWORD WINAPI Collect(
								LPWSTR lpwszValue, 
								LPVOID *lppData, 
								LPDWORD lpcbBytes, 
								LPDWORD lpcObjectTypes)
{
	type.clear_all_instances();
	type.set_buffer(*lppData);

	//   
	int count = Data::get_instances_count();

	for (int i = 0; i < count;i++)
	{
		WCHAR* name = 0;
		int    name_len = 0;

		//     .     malloc-
		Data::get_name(i, &name, &name_len);

		if (type.get_next_length(name) > *lpcbBytes)
		{
			//  
			free(name);
			*lpcbBytes = 0;
			*lpcObjectTypes = 0;
			return ERROR_MORE_DATA;
		}

		type.write_instance(name);
		type.write_last_counter(0, Data::get_data(i));

		free(name);
	}

	type.write_header();

	//   
	*lppData        = (char*)(*lppData) + type.get_total_length();
	*lpcbBytes      = type.get_total_length();
	*lpcObjectTypes = 1;

	return ERROR_SUCCESS;
}

extern "C" __declspec(dllexport) DWORD WINAPI Close()
{
	return ERROR_SUCCESS;
}


/////////////////////////////////////
//
//  
//
/////////////////////////////////////

HINSTANCE hInst = 0;

STDAPI DllRegisterServer()
{
	return Registry::DllRegister((HMODULE)hInst);
}

STDAPI DllUnregisterServer()
{
	return Registry::DllUnregister();
}

BOOL APIENTRY DllMain(HINSTANCE hInstance, DWORD reason, LPVOID)
{
	if (reason == DLL_PROCESS_ATTACH)
	{
		hInst = hInstance;
	}

	return TRUE;
}

///////////////////////////////////////////////////////